<?php

class ControllerExtensionModuleDntradeApi extends Controller {

    private $error = array();

    public function index() {

	$this->load->language('extension/module/dntrade_api');

	$this->document->setTitle($this->language->get('heading_title'));

	$this->load->model('setting/setting');

	if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
	    $this->model_setting_setting->editSetting('module_dntrade_api', $this->request->post);

	    $this->session->data['success'] = $this->language->get('text_success');

	    $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
	}

	$data['heading_title'] = $this->language->get('heading_title');

	$data['text_edit'] = $this->language->get('text_edit');
	$data['text_token'] = $this->language->get('text_token');

	$data['entry_token'] = $this->language->get('entry_token');

	$data['error_warning'] = isset($this->error['warning']) ? $this->error['warning'] : '';

	$data['breadcrumbs'] = array();

	$data['breadcrumbs'][] = array(
	    'text' => $this->language->get('text_home'),
	    'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
	);

	$data['breadcrumbs'][] = array(
	    'text' => $this->language->get('text_extension'),
	    'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
	);

	$data['breadcrumbs'][] = array(
	    'text' => $this->language->get('heading_title'),
	    'href' => $this->url->link('extension/module/dntrade_api', 'user_token=' . $this->session->data['user_token'], true)
	);

	$data['action'] = $this->url->link('extension/module/dntrade_api', 'user_token=' . $this->session->data['user_token'], true);

	$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

	if (isset($this->request->post['module_dntrade_api_token'])) {
	    $data['module_dntrade_api_token'] = $this->request->post['module_dntrade_api_token'];
	} else {
	    $data['module_dntrade_api_token'] = $this->config->get('module_dntrade_api_token');
	}

	if (isset($this->request->post['module_dntrade_api_status'])) {
	    $data['module_dntrade_api_status'] = $this->request->post['module_dntrade_api_status'];
	} else {
	    $data['module_dntrade_api_status'] = $this->config->get('module_dntrade_api_status');
	}

	$data['header'] = $this->load->controller('common/header');
	$data['column_left'] = $this->load->controller('common/column_left');
	$data['footer'] = $this->load->controller('common/footer');
	$data['error_token'] = "";

	$this->response->setOutput($this->load->view('extension/module/dntrade_api', $data));
    }

    public function install() {
	$this->load->model('setting/setting');
	$this->model_setting_setting->editSetting('module_dntrade_api', array('module_dntrade_api_token' => ''));
    }

    public function uninstall() {
	$this->load->model('setting/setting');
	$this->model_setting_setting->deleteSetting('module_dntrade_api');
    }

    private function validate() {
	if (!$this->user->hasPermission('modify', 'extension/module/dntrade_api')) {
	    $this->error['warning'] = $this->language->get('error_permission');
	}

	if (!$this->request->post['module_dntrade_api_token']) {
	    $this->error['warning'] = $this->language->get('error_token');
	}

	return !$this->error;
    }
}
