<?php

class ModelExtensionModuleDntradeApi extends Model {

    public function isEnabled() {
	return $this->config->get('module_dntrade_api_status');
    }

    public function getApiToken() {
	return $this->config->get('module_dntrade_api_token');
    }

    public function getOrders($from_date = "", $limit = "", $offset = "") {
	$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order WHERE 1" . ($from_date ? " AND (date_added >= '{$from_date}' OR date_modified >= '{$from_date}')" : "") . ($limit ? " LIMIT {$limit}" : "") . ($offset ? " OFFSET {$offset}" : ""));

	return $query->rows;
    }

    public function getOrderProducts($order_id) {
	$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int) $order_id . "'");

	return $query->rows;
    }

    public function editProduct($product_id, $data, $language_id) {
	// Підготовка запиту на оновлення інформації про товар
	$sql = [];
	foreach ($data as $key => $value) {
	    if (in_array($key, ['sku', 'ean', 'quantity', 'price', 'status'])) {
		$sql[] = $key . " = '" . $this->db->escape($value) . "'";
	    }
	}

	if (!empty($sql)) {
	    $this->db->query("UPDATE " . DB_PREFIX . "product SET " . (implode(", ", $sql)) . ", date_modified = NOW() WHERE product_id = " . (int) $product_id);
	}

	if (isset($data['name'])) {
	    $this->db->query("UPDATE " . DB_PREFIX . "product_description SET name = '" . $this->db->escape($data['name']) . "' WHERE product_id = '" . (int) $product_id . "' AND language_id = {$language_id}");
	}

	if (isset($data['images'])) {
	    if (!empty($data['images'][0])) {
		$image_name = $this->uploadImage($product_id, $data['images'][0]);
		if (!empty($image_name))
		    $this->db->query("UPDATE " . DB_PREFIX . "product SET image = '" . $this->db->escape($image_name) . "' WHERE product_id = '" . (int) $product_id . "'");
	    }
	}
	if (isset($data['price'])) {
	    $this->db->query("DELETE FROM " . DB_PREFIX . "product_special WHERE product_id = '" . (int) $product_id . "'");
	    if (isset($data['price_special']) && $data['price_special'] < $data['price']) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "product_special SET product_id = '" . (int) $product_id . "', price = '" . (float) $data['price_special'] . "'");
	    }
	}

	if (isset($data['images']) && count($data['images']) > 1) {
	    $this->db->query("DELETE FROM " . DB_PREFIX . "product_image WHERE product_id = '" . (int) $product_id . "'");
	    foreach ($data['images'] as $sort => $product_image) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "product_image SET product_id = '" . (int) $product_id . "', image = '" . $this->db->escape($product_image) . "', sort_order = '" . (int) $sort . "'");
	    }
	}

	$this->cache->delete('product');
    }

    private function uploadImage($product_id, $image_url) {
// Отримання розширення файлу
	$image_extension = pathinfo($image_url, PATHINFO_EXTENSION);

// Генерація назви файлу на сервері
	$image_filename = 'product_' . $product_id . '.' . $image_extension;

// Завантаження зображення з зовнішнього джерела на сервер
	$image_data = @file_get_contents($image_url);
	if (!empty($image_data)) {
	    file_put_contents(DIR_IMAGE . $image_filename, $image_data);
	    return $image_filename;
	}
    }

    public function addProduct($data, $language_id) {
	$this->db->query("INSERT INTO " . DB_PREFIX . "product SET sku = '" . $this->db->escape($data['sku']) . "', ean = '" . $this->db->escape($data['ean']) . "', quantity = '" . ((int) $data['quantity'] ?? 0) . "', price = '" . (float) $data['price'] . "', status = '1', date_added = NOW(), date_modified = NOW()");

	$product_id = $this->db->getLastId();	
	if (isset($data['images'])) {
	    if (!empty($data['images'][0])) {
		$image_name = $this->uploadImage($product_id, $data['images'][0]);
		if (!empty($image_name))
		    $this->db->query("UPDATE " . DB_PREFIX . "product SET image = '" . $this->db->escape($image_name) . "' WHERE product_id = '" . (int) $product_id . "'");
	    }
	}

	$this->db->query("INSERT INTO " . DB_PREFIX . "product_description SET product_id = '" . (int) $product_id . "', language_id = '" . (int) $language_id . "', name = '" . $this->db->escape($data['name']) . "', description = '" . $this->db->escape($data['description']) . "', meta_title = '" . $this->db->escape($data['name']) . "', meta_description = '" . $this->db->escape($data['name']) . "', meta_keyword = '" . $this->db->escape($data['name']) . "'");

	$this->db->query("INSERT INTO " . DB_PREFIX . "product_to_store SET product_id = '" . (int) $product_id . "', store_id = '" . (int)$this->config->get('config_store_id') . "'");
	    

	if (isset($data['price'])) {
	    if (isset($data['price_special']) && $data['price_special'] < $data['price']) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "product_special SET product_id = '" . (int) $product_id . "', price = '" . (float) $data['price_special'] . "'");
	    }
	}

	if (isset($data['images']) && count($data['images']) > 1) {
	    $this->db->query("DELETE FROM " . DB_PREFIX . "product_image WHERE product_id = '" . (int) $product_id . "'");
	    foreach ($data['images'] as $sort => $product_image) {
		$image_name = $this->uploadImage($product_id, $product_image);
		$this->db->query("INSERT INTO " . DB_PREFIX . "product_image SET product_id = '" . (int) $product_id . "', image = '" . $this->db->escape($image_name) . "', sort_order = '" . (int) $sort . "'");
	    }
	}

	if (isset($data['parent_id'])) {
	    $this->db->query("INSERT INTO " . DB_PREFIX . "product_to_category SET product_id = '" . (int) $product_id . "', category_id = '" . (int) $data['parent_id'] . "'");	    
	}
	$this->cache->delete('product');
	return $product_id;
    }
    
    public function editOrderStatus($order_id, $status_id) {
        // Перевірка наявності вказаного статусу в базі даних
        $query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "order_status WHERE order_status_id = '" . (int)$status_id . "'");

        if ($query->row['total']) {
            // Зміна статусу замовлення, якщо статус існує в базі даних
            $this->db->query("UPDATE " . DB_PREFIX . "order SET order_status_id = '" . (int)$status_id . "' WHERE order_id = '" . (int)$order_id . "'");
            return true; // Повернення true в разі успішної зміни статусу
        } else {
            return false; // Повернення false, якщо статус не існує в базі даних
        }
    }
}
